; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      qisort    PROTO :DWORD,:DWORD,:DWORD
      split     PROTO :DWORD,:DWORD,:DWORD
      isort     PROTO :DWORD,:DWORD,:DWORD

    .code

align 4

; 

qisort proc arr:DWORD,i:DWORD,j:DWORD

    push edi

    mov eax, j
    sub eax, i
    cmp eax, 48                 ; minimum size for qisort
    jb islbl                    ; else insertion sort

  ; ----------------------------

    invoke split,arr,i,j
    mov edi, eax

    sub edi, 1
    invoke qisort,arr,i,edi

    add edi, 1
    invoke qisort,arr,edi,j
    jmp @F

  align 4
  islbl:
    invoke isort,arr,i,j

  ; ----------------------------
  @@:

    pop edi

    ret

qisort endp

; 

align 4

split proc arr:DWORD,lb:DWORD,ub:DWORD

    push ebx
    push esi
    push edi
    push ebp

    mov ebx, arr                ; array address in EBX
    sub ebx, 4
    mov edx, ub                 ; upper bound
    mov esi, ub
    mov edi, [ebx+esi*4]
    mov ebp, lb                 ; lower bound
  ; *******************************************
    cmp ebp, edx
    ja lpout
  @@:
    add ebp, 1
  ulin:
    cmp [ebx+ebp*4], edi
    jb @B
  ; -------------------------
    add edx, 1
  @@:
    sub edx, 1
    cmp ebp, edx
    ja lpout
    cmp [ebx+edx*4], edi
    jnb @B
  ; -------------------------
    mov eax, [ebx+edx*4]
    mov ecx, [ebx+ebp*4]
    mov [ebx+ebp*4], eax
    mov [ebx+edx*4], ecx
    add ebp, 1
    sub edx, 1

    cmp ebp, edx
    jbe ulin
  ; *******************************************
  lpout:
    mov eax, [ebx+esi*4]
    mov ecx, [ebx+ebp*4]
    mov [ebx+ebp*4], eax
    mov [ebx+esi*4], ecx

    mov eax, ebp

    pop ebp
    pop edi
    pop esi
    pop ebx

    ret

split endp


; 

align 4

isort proc arr:DWORD,lb:DWORD,ub:DWORD

    push ebx
    push esi
    push edi

    mov ebx, arr                ; array address in EBX
    sub ebx, 4
    mov esi, lb                 ; For i = Lb + 1 To Ub '' i = ub
    add esi, 1                  ; esi = lb + 1
    jmp jmpin

  align 4
  outer:
  ; *******************
    mov edx, [ebx+esi*4]        ; t = arr(i)
    mov edi, esi                ; For j = i - 1 To Lb Step - 1
    sub edi, 1
    jmp intoit
  align 4
  inner:
    cmp [ebx+edi*4], edx
    jbe outofit                 ; insertion point found
    mov eax, [ebx+edi*4]
    mov [ebx+edi*4+4], eax      ; move arr(j) up 1
    sub edi, 1
  intoit:
    cmp edi, lb
    jge inner                   ; Next
  ; *******************
  outofit:
    mov [ebx+edi*4+4], edx      ; insert
    add esi, 1
  jmpin:
    cmp esi, ub
    jbe outer                   ; Next

    pop edi
    pop esi
    pop ebx

    ret

isort endp

; 

end
